const searchData = {"envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 5, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.intersphinx": 1, "repo_docs.ext.enhanced_search": 1, "sphinx": 56}, "data": [{"id": 0, "doc_id": 0, "filename": "contents.html", "domain_name": "std", "name": "contents", "display_name": "Contents", "type": "doc", "display_type": "Page", "docname": "contents", "anchor": "", "priority": -1, "content": "Introduction About Nsight Eclipse Plugins Edition Using Nsight Eclipse Edition Installing Nsight Eclipse Edition Installing CUDA Toolkit Configure CUDA Toolkit Path Nsight Eclipse Main Window Creating a New Project Importing CUDA Samples cuHook Sample Configure Build Settings Debugging CUDA Applications Remote development of CUDA Applications Debugging Remote CUDA Applications Improving Remote Debugging Performance Profiling CUDA applications Build CUDA Projects inside a Docker Container Remote debugging using CUDA GDB inside Docker container Importing Nsight Eclipse Projects More Information Known Issues Notices Notice OpenCL Trademarks", "keywords": []}, {"id": 1, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#about-nsight-eclipse-plugins-edition", "display_name": "About Nsight Eclipse Plugins Edition", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "about-nsight-eclipse-plugins-edition", "priority": -1, "content": "NVIDIA \u00ae Nsight\u2122 Eclipse Edition is a unified CPU plus GPU integrated development environment (IDE) for developing CUDA \u00ae applications on Linux and Mac OS X for the x86, POWER and ARM platforms. It is designed to help developers on all stages of the software development process. Nsight Eclipse Plugins can be installed on vanilla Eclipse using the standard Help-&gt;Install New Software.. Menu. The principal features are as follows: Edit, build, debug and profile CUDA-C applications CUDA aware source code editor \u2013 syntax highlighting, code completion and inline help Graphical user interface for debugging heterogeneous applications Profiler integration \u2013 Launch visual profiler as an external application with the CUDA application built in this IDE to easily identify performance bottlenecks For more information about Eclipse Platform, visit http://eclipse.org LegacyDitaAnchor using-nsight", "keywords": []}, {"id": 2, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#build-cuda-projects-inside-a-docker-container", "display_name": "Build CUDA Projects inside a Docker Container", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "build-cuda-projects-inside-a-docker-container", "priority": -1, "content": "You can build and debug C/C++ and CUDA projects in a Docker container using Nsight Eclipse Edition. To get started, you need to first pull and install the Docker image that encapsulates the CUDA toolkit and cross platform tool chains. You can get the Docker images from NVIDIA GPU Cloud.Then you can use Nsight Eclipse Edition to build CUDA projects in a Docker container. Open Nsight Eclipse Edition and configure the container settings. Open the Preferences page, Window &gt; Preferences and go to: CUDA &gt; Container Settings Select the option if you want to build the projects inside the Docker container. Make sure the CUDA toolkit path that is specified in the CUDA preferences is the path of the CUDA toolkit inside a Docker container. Select the Connection and the Image dropdown will display all the Docker images that are currently installed. Choose the docker image that you want to use to build/debug the projects. The preferences that are set here will be automatically displayed in the project setup wizard. You can choose to modify the container settings for the individual projects from the project setup wizard. To create a project, From the main menu, open the new project wizard: File &gt; New\u2026 &gt; CUDA C/C++ Project Specify the project name and project files location. And select the CUDA toolchain from the list of toolchains. In the last page of project setup wizard, the container options will be displayed. The default container settings from the preference page will be displayed here. You can choose to modify the settings for this project in this Container settings page. Complete the project setup wizard. The project will be created and shown in the Project Explorer view. The project source directories will be automatically mounted to the docker container. If you need to mount any other directories that contains the include files/libraries and etc to the docker container, you can mount those directories from the project property page. Right click on the project and go to Properties. Select C/C++ Build &gt; Settings &gt; Container Settigns Tab. Additional directories can be mounted from this property page. Build the project by hitting the hammer button on the main toolbar. The project is now built in the chosen Docker container the executable will be available on the host. LegacyDitaAnchor remote-debugging-docker", "keywords": []}, {"id": 3, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#configure-build-settings", "display_name": "Configure Build Settings", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "configure-build-settings", "priority": -1, "content": "To define build settings: In the C/C++ Projects view, right-click your project, and select Properties. Select C/C++ Build, Settings from the list. The following are the categories of Nvcc linker settings that can be configured for the selected project. All options field in the main page is not editable and it\u2019s the collection of options set in the child categories. Libraries - Configure library search path(-L) and to include linker libraries(-l). When you are cross compiling for different target os, the library search path should point to the appropriate location where the target os libraries are present. Miscellaneous - Set additional linker options and option to link with OpenGL libraries. Shared Library Settings - Set option to build a shared library. The following are the categories of Nvcc Compiler settings that can be configured for the selected project. All options field in the main page is not editable and it\u2019s the collection of options set in the child categories. Dialect - Select the language standard and dialect options. Preprocessor - Add the defined and undefined symbols for the preprocessor. Includes - Set include paths and include files for the compiler. Optimization - Set the compiler optimization level. Debugging - Set the options to generate debug information. Warnings - Set inhibit all warning messages. CUDA - Generate code for different real architectures with the PTX for the same vitrual architectures. LegacyDitaAnchor debugging", "keywords": []}, {"id": 4, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#configure-cuda-toolkit-path", "display_name": "Configure CUDA Toolkit Path", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "configure-cuda-toolkit-path", "priority": -1, "content": "When Eclipse is first launched with Nsight Eclipse plugins in the new workspace, NVIDIA usage data collection dialog will be displayed as below. Click Yes to enable usage collection. This can be disabled later from the CUDA preference page. Usage data collection page To get started, CUDA Toolkit path must be configured in Eclipse with Nsight Plugins: Open the Preferences page, Window &gt; Preferences. Go to CUDA toolkit section. Select the CUDA toolkit path to be used by Nsight. CUDA tookits that are installed in the default location will automatically appear. CUDA toolkit path can be also specified in the project properties page in order to use different toolkit for a project. Enable usage data collection if you wish to send usage data to NVIDIA. Click on the button to set cuda-gdb and Visual Profiler as the default launchers. For QNX: When QNX is selected as Target OS, a dialog will be displayed to set the QNX_HOST and QNX_TARGET environment variables if they were not already set. QNX_HOST environment variable identifies the directory that holds the host-related components: QNX_TARGET environment variable identifies the directory that holds the target-related components: LegacyDitaAnchor running", "keywords": []}, {"id": 5, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#creating-a-new-project", "display_name": "Creating a New Project", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "creating-a-new-project", "priority": -1, "content": "From the main menu, open the new project wizard - File &gt; New\u2026 &gt; CUDA C/C++ Project Specify the project name and project files location. Specify the project type like executable project. Specify the CUDA toolchain from the list of toolchains. Specify the project configurations on the next wizard page. Complete the wizard. The project will be shown in the Project Explorer view and source editor will be opened. Build the project by clicking on the hammer button on the main toolbar. Nsight main window after creating a new project LegacyDitaAnchor import-sample", "keywords": []}, {"id": 6, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#cuhook-sample", "display_name": "cuHook Sample", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "cuhook-sample", "priority": -1, "content": "cuHook sample builds both the library and the executable. cuHook sample should be imported as the \u201cmakefile\u201d project using the following steps. From the main menu, open the new project wizard - File &gt; New\u2026 &gt; CUDA C/C++ Project Select project type \u201cMakefile project\u201d and choose \u201cEmpty Project\u201d Specify the project name and project files location. Complete the wizard. The project will be shown in the Project Explorer view. Right click on the project - Import\u2026 &gt; General &gt; File System On the next wizard page, select the location of cuHook sample(Samples/7_CUDALibraries/cuHook) Select all the source files and makefile and Finish the wizard Build the project by clicking on the hammer button on the main toolbar. To run the sample, from the main menu - Run &gt; Run Configurations\u2026 &gt; Select the executable &gt; Go to Environment tab &gt; New\u2026 &gt; enter Name=LD_PRELOAD, Value=./libcuhook.so.1 &gt; Run will execute the sample LegacyDitaAnchor build-settings", "keywords": []}, {"id": 7, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#debugging-cuda-applications", "display_name": "Debugging CUDA Applications", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "debugging-cuda-applications", "priority": -1, "content": "Nsight must be running and at least one project must exist. In the Project Explorer view, select project you want to debug. Make sure the project executable is compiled and no error markers are shown on the project. Right click on the project and go to Debug As &gt; NVIDIA CUDA GDB Debugger menu. You will be offered to switch perspective when you run debugger for the first time. Click \u201cYes\u201d. Perspective is a window layout preset specifically designed for a particular task. Application will suspend in the main function. At this point there is no GPU code running. Add a breakpoint in the device code. Resume the application. Debugger will break when application reaches the breakpoint. You can now explore your CUDA device state, step through your GPU code or resume the application. Debugging CUDA application Additional debugger options can be set in the debug configuration dialog through Run &gt; Debug Configurations .. menu.. Debugging CUDA application LegacyDitaAnchor remote-development", "keywords": []}, {"id": 8, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#debugging-remote-cuda-applications", "display_name": "Debugging Remote CUDA Applications", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "debugging-remote-cuda-applications", "priority": -1, "content": "Remote debugging is available starting with CUDA Toolkit 5.5. A dedicated GPU is not required to use Nsight remote debugging UI. A dedicated GPU is still required on the debug target. Only Linux targets are supported. Debug host and target may run different operating systems or have different CPU architectures. The remote machine must be accessible via SSH and CUDA Toolkit must be installed on both machines. If there is a firewall between the host and the target, it must be set up to let RSP messages through, or SSH port-forwarding must be used. Select the project and right click then go to Debug As\u2026&gt;NVIDIA CUDA GDB Debugger(Remote) menu item. Type the full path to a local executable or select one using the Local file\u2026 button. Select a remote connection from a drop-down list or press the Add connection\u2026 button to create a new one. If you are creating a new remote connection, enter the host name(or IP address) as well as the user name. Select the SSH as system type. Also select the QNX check box for QNX targets and then press Finish. For Android devices: To configure the remote connection using Android debug bridge, select the Android debug bridge from the Remote Connection drop-down list, Android device must be connected to the host system using USB port. Press Manage button, and enter or select the path to adb utility. You need to install Android SDK platform tools to use Android debug bridge. press Detect button to find the android device available through ADB. Optional: Press Connect to verify the selected remote connection. Press the Next button. Type the full path to cuda-gdbserver on the remote system or select one using the Browse\u2026 button. Click on \u201cAdd new path\u201d or on the Browse\u2026 button to specify the path to the shared libraries the remote application depends on. Click on the Finish button to finish the new debug configuration wizard and start debugging the application. You will be offered to switch perspective when you run the debugger for the first time. Click Yes. Perspective is a window layout preset specifically designed for a particular task. The debugger will stop at the application main routine. You can now set breakpoints, or resume the application. Debugging remote CUDA application LegacyDitaAnchor improving-remote-debugging-performance", "keywords": []}, {"id": 9, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#importing-cuda-samples", "display_name": "Importing CUDA Samples", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "importing-cuda-samples", "priority": -1, "content": "The CUDA samples are an optional component of the CUDA Toolkit installation. Nsight provides a mechanism to import these samples and work with them easily: Samples that use the CUDA driver API (suffixed with \u201cDrv\u201d) are not supported by Nsight. From the main menu, open the new project wizard - File &gt; New\u2026 &gt; CUDA C/C++ Project Specify the project name and project files location. Select Import CUDA Sample under Executable in the Project type tree. Select CUDA toolchain from the Toolchains option. location. On the next wizard page select project sample you want to import. Also select the target CPU architecture. Press Next\u2026 Specify the project parameters on the next wizard page. Complete the wizard. The project will be shown in the Project Explorer view and source editor will be opened. Build the project by clicking on the hammer button on the main toolbar. LegacyDitaAnchor cuhook-sample", "keywords": []}, {"id": 10, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#importing-nsight-eclipse-projects", "display_name": "Importing Nsight Eclipse Projects", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "importing-nsight-eclipse-projects", "priority": -1, "content": "The projects that are created with Nsight Eclipse Edition can be imported into the Eclipse workbench with Nsight Eclipse plugins. Open Nsight Eclipse edition and select the project that needs to be exported. Right click on the Nsight Eclipse project and go to - Export &gt; C/C++ &gt; C/C++ Project Settings &gt; Next menu. Select the project and settings to export. Specify the \u201cExport to file\u201d location. Settings will be stored in the given XML file. Go to Eclipse workbench where the project settings needs to be imported. Create a CUDA C/C++ Project from the main menu File &gt; New &gt; CUDA C/C++ Project Specify the project name and choose Empty project type with CUDA toolchains. Right click on the project to import the source files. Import &gt; General &gt; File System &gt;(From directory) or copy the source files from the existing project. Import the project settings like include paths and symbols using the following right click menu Import &gt; C/C++ &gt; C/C++ Project Settings &gt;Next\u2026 Select the location of the project settigns file and select the project and configuration on the next wizard page. Complete the wizard. The project settings will be imported from the file exported from Nsight Eclipse Edition. Build the project by clicking on the hammer button on the main toolbar. LegacyDitaAnchor more-information", "keywords": []}, {"id": 11, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#improving-remote-debugging-performance", "display_name": "Improving Remote Debugging Performance", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "improving-remote-debugging-performance", "priority": -1, "content": "When doing remote debugging, it can be useful to host copies of the target libraries in a local sysroot. Starting with CUDA 11.5, this feature is available on the Debugger Configurations -&gt; Debugger tab. You can modify \u2018CUDA GDB sysroot (for remote debugging)\u2019 to point to a local sysroot directory to improve debugging performance. LegacyDitaAnchor profiling", "keywords": []}, {"id": 12, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#installing-cuda-toolkit", "display_name": "Installing CUDA Toolkit", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "installing-cuda-toolkit", "priority": -1, "content": "To install CUDA Toolkit: Visit the NVIDIA CUDA Toolkit download page: https://developer.nvidia.com/cuda-downloads Select appropriate operating system. Nsight Eclipse Edition is available in Mac OS X and Linux toolkit packages. Download and install the CUDA Driver. Download and install the CUDA Toolkit. Follow instructions to configure CUDA Driver and Toolkit on your system. LegacyDitaAnchor configure-cuda-toolkit", "keywords": []}, {"id": 13, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#installing-nsight-eclipse-edition", "display_name": "Installing Nsight Eclipse Edition", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "installing-nsight-eclipse-edition", "priority": -1, "content": "Nsight Eclipse Plugins archive is part of the CUDA Toolkit. Nsight Eclipse Plugins archive can be installed using the Help -&gt; Install New Software\u2026 Menu on Eclipse LegacyDitaAnchor toolkit-installation", "keywords": []}, {"id": 14, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#known-issues", "display_name": "Known Issues", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "known-issues", "priority": -1, "content": "Executable must exist in order to start debug session for the first time Nsight will not automatically perform build when starting debug session for a given project for the first time. Build must be invoked manually. Nsight will automatically rebuild executable when starting subsequent debug sessions. To manually build the project, select it (or any file within the project) in a Project Explorer view and click hammer icon on the main window toolbar. Source editors may show error markers on a valid code for the files in newly created projects. These markers will be cleared after Nsight indexes included header files. Mac OS X users may be prompted to install Java Runtime Environment (JRE) when running Nsight Eclipse Edition for the first time. Nsight Eclipse Plugin Edition requires functioning Java Runtime Environment to be present on the local system to run. Nsight Eclipse Plugin Edition does not provide compilation support for using the QNX qcc and q++ compilers. The workaround to compile using qcc and q++ is Specify the q++ path in CCBIN field on toolkit configuration page on project properties dialog as shown below. You can access toolkit configuration page by clicking main menu Project &gt; Properties &gt; C/C++ Build &gt; CUDA Toolkit Change default CONF to gcc_ntoaarch64le in the file ${QNX_HOST}/etc/qcc/gcc/5.4.0/default as below CONF=gcc_ntoaarch64le LegacyDitaAnchor notice", "keywords": []}, {"id": 15, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#more-information", "display_name": "More Information", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "more-information", "priority": -1, "content": "More information about the Eclipse CDT features and other topics is available in the Help contents. To access Help contents select Help-&gt;Help Contents from the Nsight main menu. More information about CUDA, CUDA Toolkit and other tools is available on CUDA web page at http://developer.nvidia.com/cuda LegacyDitaAnchor known-issues", "keywords": []}, {"id": 16, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#notice", "display_name": "Notice", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "notice", "priority": -1, "content": "This document is provided for information purposes only and shall not be regarded as a warranty of a certain functionality, condition, or quality of a product. NVIDIA Corporation (\u201cNVIDIA\u201d) makes no representations or warranties, expressed or implied, as to the accuracy or completeness of the information contained in this document and assumes no responsibility for any errors contained herein. NVIDIA shall have no liability for the consequences or use of such information or for any infringement of patents or other rights of third parties that may result from its use. This document is not a commitment to develop, release, or deliver any Material (defined below), code, or functionality. NVIDIA reserves the right to make corrections, modifications, enhancements, improvements, and any other changes to this document, at any time without notice. Customer should obtain the latest relevant information before placing orders and should verify that such information is current and complete. NVIDIA products are sold subject to the NVIDIA standard terms and conditions of sale supplied at the time of order acknowledgement, unless otherwise agreed in an individual sales agreement signed by authorized representatives of NVIDIA and customer (\u201cTerms of Sale\u201d). NVIDIA hereby expressly objects to applying any customer general terms and conditions with regards to the purchase of the NVIDIA product referenced in this document. No contractual obligations are formed either directly or indirectly by this document. NVIDIA products are not designed, authorized, or warranted to be suitable for use in medical, military, aircraft, space, or life support equipment, nor in applications where failure or malfunction of the NVIDIA product can reasonably be expected to result in personal injury, death, or property or environmental damage. NVIDIA accepts no liability for inclusion and/or use of NVIDIA products in such equipment or applications and therefore such inclusion and/or use is at customer\u2019s own risk. NVIDIA makes no representation or warranty that products based on this document will be suitable for any specified use. Testing of all parameters of each product is not necessarily performed by NVIDIA. It is customer\u2019s sole responsibility to evaluate and determine the applicability of any information contained in this document, ensure the product is suitable and fit for the application planned by customer, and perform the necessary testing for the application in order to avoid a default of the application or the product. Weaknesses in customer\u2019s product designs may affect the quality and reliability of the NVIDIA product and may result in additional or different conditions and/or requirements beyond those contained in this document. NVIDIA accepts no liability related to any default, damage, costs, or problem which may be based on or attributable to: (i) the use of the NVIDIA product in any manner that is contrary to this document or (ii) customer product designs. No license, either expressed or implied, is granted under any NVIDIA patent right, copyright, or other NVIDIA intellectual property right under this document. Information published by NVIDIA regarding third-party products or services does not constitute a license from NVIDIA to use such products or services or a warranty or endorsement thereof. Use of such information may require a license from a third party under the patents or other intellectual property rights of the third party, or a license from NVIDIA under the patents or other intellectual property rights of NVIDIA. Reproduction of information in this document is permissible only if approved in advance by NVIDIA in writing, reproduced without alteration and in full compliance with all applicable export laws and regulations, and accompanied by all associated conditions, limitations, and notices. THIS DOCUMENT AND ALL NVIDIA DESIGN SPECIFICATIONS, REFERENCE BOARDS, FILES, DRAWINGS, DIAGNOSTICS, LISTS, AND OTHER DOCUMENTS (TOGETHER AND SEPARATELY, \u201cMATERIALS\u201d) ARE BEING PROVIDED \u201cAS IS.\u201d NVIDIA MAKES NO WARRANTIES, EXPRESSED, IMPLIED, STATUTORY, OR OTHERWISE WITH RESPECT TO THE MATERIALS, AND EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES OF NONINFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE. TO THE EXTENT NOT PROHIBITED BY LAW, IN NO EVENT WILL NVIDIA BE LIABLE FOR ANY DAMAGES, INCLUDING WITHOUT LIMITATION ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL, PUNITIVE, OR CONSEQUENTIAL DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF ANY USE OF THIS DOCUMENT, EVEN IF NVIDIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. Notwithstanding any damages that customer might incur for any reason whatsoever, NVIDIA\u2019s aggregate and cumulative liability towards customer for the products described herein shall be limited in accordance with the Terms of Sale for the product. LegacyDitaAnchor opencl", "keywords": []}, {"id": 17, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#notices", "display_name": "Notices", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "notices", "priority": -1, "content": "", "keywords": []}, {"id": 18, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#nsight-eclipse-main-window", "display_name": "Nsight Eclipse Main Window", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "nsight-eclipse-main-window", "priority": -1, "content": "On the first run Eclipse will ask to pick a workspace location. The workspace is a folder where Nsight will store its settings, local files history and caches. An empty folder should be selected to avoid overwriting existing files. The main Nsight window will open after the workspace location is selected. The main window is divided into the following areas: Editor - displays source files that are opened for editing. Project Explorer - displays project files Outline - displays structure of the source file in the current editor. Problems - displays errors and warnings detected by static code analysis in IDE or by a compiler during the build. Console - displays make output during the build or output from the running application. LegacyDitaAnchor new-runtime-project", "keywords": []}, {"id": 19, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#opencl", "display_name": "OpenCL", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "opencl", "priority": -1, "content": "OpenCL is a trademark of Apple Inc. used under license to the Khronos Group Inc. LegacyDitaAnchor trademarks", "keywords": []}, {"id": 20, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#profiling-cuda-applications", "display_name": "Profiling CUDA applications", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "profiling-cuda-applications", "priority": -1, "content": "Nsight must be running and at least one project must exist. Profiler cannot be used when debugging session is in progress. Nsight Eclipse Edition profiling features are based on the NVIDIA Visual Profiler ( nvvp ) code. Nsight Eclipse Plugins Edition will launch the Visual Profiler as an external tool with the executable and other information from the selected project. In the Project Explorer view, select project you want to profile. Make sure the project executable is compiled and no error markers are shown on the project. Select the project and right click and go to Profile As&gt;NVIDIA Visual Profiler menu. Nsight Eclipse will launch the Visual Profiler to specify extra profiler options with the executable information already passed from the selected project. Profiling CUDA Application LegacyDitaAnchor build-projects-docker", "keywords": []}, {"id": 21, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#remote-debugging-using-cuda-gdb-inside-docker-container", "display_name": "Remote debugging using CUDA GDB inside Docker container", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "remote-debugging-using-cuda-gdb-inside-docker-container", "priority": -1, "content": "From Nsight Eclipse, you can remote debug the applications running on the target using the CUDA GDB inside the Docker container running on the host. Docker images with CUDA GDB and CUDA toolkit must be already installed on the host. The remote machine must be accessible via SSH and CUDA Toolkit must be installed on target machine. If there is a firewall between the host and the target, it must be set up to let RSP messages through, or SSH port-forwarding must be used. From the main menu, goto Run&gt;Debug Configurations\u2026 menu item. Create a new debug configuration under CUDA GDB Container Launcher either double clicking or using right click menu. Configure the remote connection details in the \u201cRemote\u201d tab. If you are creating a new remote connection, click on the manage button in Remote Connection enter the host name(or IP address) as well as the user name. Select the SSH as system type. Also select the CUDA toolkit location on the target and choose the location to where to upload the executable. Choose the project and the executable to upload to the target in the \u201cLocal\u201d tab. From the \u201cContainer\u201d tab, select the connection and Docker image that contains the CUDA GDB. Also you can select any host directories required to mounted to the Docker container. Select the debugger options from the \u201cDebugger\u201d Tab. Make sure to enter the CUDA GDB executable path inside Docker container. And add the required environment variables in the \u201cEnvironment\u201d tab. Click on the Apply button to save the changes and click on the Debug button to start the debug session. This action will upload the local executable to the target system and will start CUDA GDB Server on the target. And the Docker container will be started on the host and CUDA GDB running inside the docker container will establish the remote debug session with the target. You will be offered to switch perspective when you run the debugger for the first time. Click Yes. Perspective is a window layout preset specifically designed for a particular task. The debugger will stop at the application main routine. You can now set breakpoints, or resume the application. Debugging remote CUDA application LegacyDitaAnchor import-nsight-project", "keywords": []}, {"id": 22, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#remote-development-of-cuda-applications", "display_name": "Remote development of CUDA Applications", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "remote-development-of-cuda-applications", "priority": -1, "content": "Nsight Eclipse Edition also supports remote development of CUDA application starting with CUDA Toolkit 6.0. The picture below shows how Nsight Eclipse Edition can be used for local as well as remote development: For remote development you do not need any NVIDIA GPU on your host system. The remote target system can be a Linux x86 or POWER system with an NVIDIA GPU or an Tegra-based ARM system. Nsight IDE and UI tools can only be hosted on x86 and POWER systems. Nsight Eclipse Plugins supports the cross compilation mode for remote devices. In the cross compilation mode the project resides on the host system and the cross compilation is also done on the host system. The cross compilation mode is only supported on an Ubuntu x86 host system. To cross compile select the target cross compile architecture in CPU architecture drop down in the project properties page: LegacyDitaAnchor remote-debugging", "keywords": []}, {"id": 23, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#trademarks", "display_name": "Trademarks", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "trademarks", "priority": -1, "content": "NVIDIA and the NVIDIA logo are trademarks or registered trademarks of NVIDIA Corporation in the U.S. and other countries. Other company and product names may be trademarks of the respective companies with which they are associated.", "keywords": []}, {"id": 24, "doc_id": 25, "filename": "index.html", "domain_name": "page", "name": "index#using-nsight-eclipse-edition", "display_name": "Using Nsight Eclipse Edition", "type": "section", "display_type": "Page section", "docname": "index", "anchor": "using-nsight-eclipse-edition", "priority": -1, "content": "LegacyDitaAnchor installation-instructions", "keywords": []}, {"id": 25, "doc_id": 25, "filename": "index.html", "domain_name": "std", "name": "index", "display_name": "Introduction", "type": "doc", "display_type": "Page", "docname": "index", "anchor": "", "priority": -1, "content": "Nsight Eclipse Plugins Edition Getting Started Guide The user guide for using Nsight Eclipse Plugins Edition. LegacyDitaAnchor introduction This guide introduces Nsight Eclipse Plugins Edition and provides instructions necessary to start using this tool. Nsight Eclipse is based on Eclipse CDT project. For a detailed description of Eclipse CDT features consult the integrated help \u201cC/C++ Development User Guide\u201d available from inside Nsight (through Help-&gt;Help Contents menu). LegacyDitaAnchor about-nsight", "keywords": []}]};